/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker;


import org.ow2.dsrg.fm.dchecker.rmi.RMIUserInterfaceImpl;

import java.io.Reader;
import org.ow2.dsrg.fm.bptools.util.Log;


/**
 * The main class of command line console used by user to pass behaviour protocols
 * to the server and obtain the result.
 *
 * The console is executed once for each protocol to be checked. It reports the
 * result and quits.
 * @author thorm
 */
public class DCheckerConsole {
    
    private static void printHelp() {
        System.out.println(
                "Usage: Console serverAddress [protocol.bp]\n"
                        + "If the protocol file is not specified, standart input is used.");
    }
    
    /**
     * Run the console on this machine
     *
     * The first argument is address of the server used to process the task and second
     * parameter is name of file containing the protocol to be checked.
     * @param args list of arguments
     * @throws java.lang.Exception thrown if something goes wrong.
     */
    public static void main(String[] args) throws Exception {
        Log.init();
        
        Reader r = null;

        if (args.length == 2) {
        
        } else {
            printHelp();
            System.exit(1);
        }
        
        RMIUserInterfaceImpl i = new RMIUserInterfaceImpl();
        
        i.run(args[0], args[1]);
        
    }
}
