/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker;


import org.ow2.dsrg.fm.dchecker.rmi.RMIServerImpl;

import java.rmi.RMISecurityManager;
import org.ow2.dsrg.fm.bptools.util.Log;


/**
 * Main class of Distributed Behaviour Protocol Checker Server.
 * 
 * The server accepts the tasks ( architecture description ) from consoles, divides
 * the work among registered clients gathers the results and reports the result to 
 * the consoles.
 * 
 * The tasks are solved one by one - not concurrently
 * @author thorm
 */
public class DCheckerServer {
    
    /**
     * Run the server on this machine
     * @param args list of arguments - does not matter
     * @throws java.lang.Exception thrown if something goes wrong.
     */
    public static void main(String args[]) throws Exception {
        Log.init();
        // Create and install a security manager
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        try {
            RMIServerImpl server = new RMIServerImpl();
            server.run();
        } catch (Exception e) {
            System.out.println("DCheckerServer err: " + e.getMessage());
            e.printStackTrace();
        }
    }
}
