/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.distributed;


import java.io.FileWriter;
import java.io.IOException;
import org.ow2.dsrg.fm.bptools.architecture.PreprocessedArchitecture;

/**
 *
 * @author thorm
 */
public class FileDump implements UserHandler{
    
    /** Creates a new instance of FileDump */
    public FileDump(String fName) {
        try{
            fw = new FileWriter(fName);
        } catch (IOException ioe){
            ioe.printStackTrace();
        }
        sb = new StringBuffer();
    }

    public void edge(int[] src, int[] target) {
    }
    

    
    public void spanningEdge(int[] src, int[] target) {
        
        sb.append("edge:");
        PreprocessedArchitecture.stateId(src,sb);
        sb.append("->");
        PreprocessedArchitecture.stateId(target,sb);
        sb.append('\n');
        try{
            fw.write(sb.toString());
        } catch (IOException ioe){
            ioe.printStackTrace();
        }
        
        sb.setLength(0);
        
    }
    
    
    public void node(int[] node) {
        sb.append("node:");
        PreprocessedArchitecture.stateId(node,sb);
        sb.append('\n');
        try{
            fw.write(sb.toString());
        } catch (IOException ioe){
            ioe.printStackTrace();
        }
        sb.setLength(0);
        
    }
    
    public void finish() {
        try{
            fw.close();
        } catch (IOException ioe){
            ioe.printStackTrace();
        }
        
    }
    
    public void init() {
    }
    
    
    
    
    FileWriter fw;
    StringBuffer sb;
}
