/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.distributed;

import org.ow2.dsrg.fm.dchecker.distributed.spacemap.BoundingBox;

/**
 *
 * @author tom
 *
 */
public class HashArea extends BFSArea{
    
    int hashValueAcceptedByThisArea;
    int hashModulo;
    int [] clientIdMap;
    /** Creates a new instance of HashArea */
    public HashArea(int acceptedValue,int hashModulo, int[] clientIdMap, BoundingBox si) {
        super(si);
        hashValueAcceptedByThisArea = acceptedValue;
        this.hashModulo = hashModulo;
        this.clientIdMap = clientIdMap;
        
    }
    
    public boolean belongs(int[] splittedState) {
        return hashFunction(splittedState)==hashValueAcceptedByThisArea;
    }
    
    public int hashFunction(int[] splittedState){
        int ret = 0;
        for (int i:splittedState){
            ret += i;
        }
        return ret%hashModulo;
    }
    
    public int belongsTo(int[] splittedState){
        return clientIdMap[hashFunction(splittedState)];
    }
}
