/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.fly;


import java.io.Serializable;


/**
 *
 * @author thorm
 */
public class BitPartInfo implements Serializable {
    
    public static BitPartInfo ZERO;
    
    static {
        ZERO = new BitPartInfo(0);
    }
    
    private BitPartInfo(int d) {
        firstBitPosition = d;
    }
    
    private static int log2(int i) {
        int newData = 0;

        while (i != 0) {
            i = i >>> 1;
            newData++;
        }
        return newData;
    }
    
    public BitPartInfo multiply(int i) {
        return new BitPartInfo(firstBitPosition + log2(i));
    }
    
    public void setUpperBound(int i) {
        int start0 = firstBitPosition % 32;

        width = log2(i);
        mask = 0;
        for (int j = 0; j < width; j++) {
            mask = (mask << 1) + 1;
        }
        for (int j = 0; j < start0; j++) {
            mask = (mask << 1);
        }
    }
    
    int firstBitPosition;
    int width; 
    long mask; 
}
