/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.fly;


import java.nio.ByteBuffer;


/**
 * Represents the state
 * @author thorm
 */
public class FlyState extends BigInt {
    
    public FlyState() {}

    
    public FlyState(int idSize){
        resize(idSize);
    }
    
    /**
     * Derived FlyState.
     * @param oldState state that is going to be modified by follow method of FlyFSM
     */
    public FlyState(FlyState oldState) {
        super(oldState);
    }
    
    
    public String toString(FlyFSM f) {
        int[] a = new int[f.getDimension()];
        
        f.getStateParts(this, a);
        StringBuffer s = new StringBuffer();
        
        for (int i = 0; i < a.length - 1; i++) {
            s.append(a[i]);
            s.append(',');
        }
        s.append(a[a.length-1]);
        return s.toString();
    }
    
    /*
    public static int byteArrayToInt (int idx,byte[] b){
        int ret = b[4*idx+3];
        ret = ret << 8;
        ret = ret | (int)b[4*idx+2];
        ret = ret << 8;
        ret = ret | (int)b[4*idx+1];
        ret = ret << 8;
        ret = ret | (int)b[4*idx];
        return ret;
    }
    
    public static void intToByteArray (int val,int idx,byte[] b){
        b[4*idx] = (byte)(val % 0x100);
        b[4*idx+1] = (byte)((val>>>8) % 0x100);
        b[4*idx+2] = (byte)((val>>>16) % 0x100);
        b[4*idx+3] = (byte)((val>>>24) % 0x100);
    }
    */
    
    public void readData(int[] b){
        for(int i = 0;i<data.length;i++){
             data[i]=b[i];
        }
        parentData = new int[data.length];
        for(int i = 0;i<parentData.length;i++){
             parentData[i]=b[i+data.length];
        }
        /*
        for(int i = 0;i<data.length;i++){
             data[i]=byteArrayToInt(i,b);
        }
        parentData = new int[data.length];
        for(int i = 0;i<parentData.length;i++){
             parentData[i]=byteArrayToInt(i+data.length,b);
        }
         */
    }
    
    public void writeData(int[] b){
        for(int i = 0;i<data.length;i++){
            b[i] = data[i];
        }

        for(int i = 0;i<parentData.length;i++){
            b[data.length+i] = parentData[i];
        }
        /*
        for(int i = 0;i<data.length;i++){
            intToByteArray(data[i],i,b);
        }

        for(int i = 0;i<parentData.length;i++){
            intToByteArray(parentData[i],data.length+i,b);
        }*/
    }
    
    
    public int[] parentData;
    
    
}

