/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.rmi;


import org.ow2.dsrg.fm.dchecker.distributed.spacemap.DistributionInfo;
import java.io.Serializable;
import java.net.InetSocketAddress;
import java.util.Map;
import java.util.Set;


/**
 *
 * @author thorm
 */
public class ClientInitData implements Serializable {
    
    /** Creates a new instance of ClientInitData */
    
    public ClientInitData(InetSocketAddress serverSocketAddress, 
            Map<Integer,InetSocketAddress> otherClients,
            DistributionInfo<Integer> initDI,
            int stateSizeInInts,
            Set<Integer> unbound) {
        this.serverAddress = serverSocketAddress;
        this.otherClients = otherClients;
        initialDI = initDI;
        this.unbound = unbound;
        this.stateSizeInInts = stateSizeInInts;
    }
    
    int stateSizeInInts;
    InetSocketAddress serverAddress;
    Map<Integer,InetSocketAddress> otherClients;
    Set<Integer> unbound;
    DistributionInfo<Integer> initialDI;
    
}
