/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.rmi;



import java.net.InetSocketAddress;
import java.rmi.Remote;
import java.rmi.RemoteException;
import org.ow2.dsrg.fm.bptools.architecture.ParsedArchitecture;


/**
 * The remote server interface
 * @author thorm
 */
public interface Server extends Remote {
    
    /**
     * Assign a new task to the server.
     *
     * @param ui
     * @param s
     * @throws java.rmi.RemoteException
     */
    void newTask(UserInterface ui, ParsedArchitecture s) throws RemoteException;
    
    /**
     * Register a new client
     *
     * @param c Client RMI stub
     * @throws java.rmi.RemoteException
     * @return assigned client identifier
     */
    int  registerClient(Client c,InetSocketAddress ia) throws RemoteException;
    
    /**
     * Unregister the client
     * @param clientId client identifier
     * @throws java.rmi.RemoteException
     */
    void unregisterClient(int clientId) throws RemoteException;
    
}
