/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.rmi;


import org.ow2.dsrg.fm.dchecker.errors.CompositionException;
import org.ow2.dsrg.fm.dchecker.fly.FlyFSM;
import org.ow2.dsrg.fm.dchecker.fly.HierarchicalFlyFSM;
import org.ow2.dsrg.fm.dchecker.fly.FlyState;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Set;


/**
 * Server-side task representation interface
 *
 * @author thorm
 */
public interface ServerTask extends Remote {
    
    
    /**
     * Used by clients to report the found error
     * @param e 
     * @throws java.rmi.RemoteException 
     */
    void errorFound(Exception e) throws RemoteException;
    
    /**
     * Used by clients to notify the server that they are iddle
     * @param clientId iddle client identifier
     * @throws java.rmi.RemoteException 
     */
    void iddleStation(int clientId,TerminationInfo ti) throws RemoteException;
    
    /**
     * Get data needed by client 
     *
     * @throws java.rmi.RemoteException 
     * @return automaton
     */
    ClientInitData getClientInitData() throws RemoteException;
    
    FlyFSM getWholeFlyFSM() throws RemoteException;
    
    void newAreaReached(FlyState fs) throws RemoteException;
    
    
    
}
