/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.rmi;

/**
 *
 * @author tom
 */
public class TimeStamps {
    
    long start;
    long areasPrepared;
    long clientsInitialized;
    long checkingComplete;
    
    void start(){
        start = System.nanoTime();
        areasPrepared = 0;
        clientsInitialized = 0;
        checkingComplete = 0;
    }
    
    void areasPrepared(){
        areasPrepared = System.nanoTime();
    }
    
    void clientsInitialized(){
        clientsInitialized = System.nanoTime();
    }
    
    void checkingComplete(){
        checkingComplete = System.nanoTime();
    }
    
    public String report(){
        StringBuilder sb = new StringBuilder();
        sb.append("FSM Creation: ");
            sb.append(nanoDifference(start, areasPrepared));
        sb.append(" Client initialization: ");
            sb.append(nanoDifference(areasPrepared, clientsInitialized));
        sb.append(" Checking: ");
            sb.append(nanoDifference(clientsInitialized, checkingComplete));
        sb.append(" Total: ");
            sb.append(nanoDifference(start, checkingComplete));
            
            
        return sb.toString();
    }
    
    String nanoDifference(long s, long f){
        long diff = f-s;
        long mili = (diff/1000000L)%1000;
        long sec = diff/1000000000L;
        String ret = Long.toString(sec) + "." +Long.toString(mili);
        return ret;
    }
}
