/* $Id$
 *
 * dChecker - Distributed Behavior Protocols Checker 
 * Copyright (C) 2006-2007  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.ow2.dsrg.fm.dchecker.rmi;


import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 * Interface of objects used by user to enter the tasks to the system
 *
 * @author thorm
 */
public interface UserInterface extends Remote {
    
    /**
     * Used by server to report the progress
     * @param m message to display
     * @throws java.rmi.RemoteException 
     */
    void msg(String e) throws RemoteException;
    
    /**
     * After invocation of this method no other message will come from the server
     * The console can be finished.
     *
     * @throws java.rmi.RemoteException 
     */
    void finish() throws RemoteException;
    
    void ping() throws RemoteException;
}
